题意:

给出一棵\(n(n \leq 4 \times 10^4)\)个节点的树,每个节点上有个权值,和\(m(m \leq 10^5)\)个询问。

每次询问路径\(u \to v\)上有多少个权值不同的点。

分析:

  • 树分块

首先将树分块,每块的大小为\(\sqrt{n}\)左右。

然后将询问离线处理,按照区间上的莫队算法将询问按块排序。

这里有一道裸的树分块的题目。

  • 树上的路径转移

定义\(S(u,v)\)表示路径\(u \to v\)上的点集,定义\(\bigoplus\)为集合的对称差,类似于异或运算。

那么有\(S(u,v)=S(root,u) \bigoplus S(root, v) \bigoplus LCA(u,v)\),有一个\(LCA\)不方便处理。

再定义一个\(T(u,v)=S(root,u) \bigoplus S(root, v)\)

\(T(u_1, v_1) \bigoplus T(v_1, v_2)=S(root, u_1) \bigoplus S(root, v_1) \bigoplus S(root, v_1) \bigoplus S(root, v_2)\)

消去中间两项得到:\(T(u_1, v_1) \bigoplus T(v_1, v_2)=S(root, u_1) \bigoplus S(root, v_2)=T(u_1, v_2)\)

从结论可以看出,由\(T(u_1,v_1)\)到\(T(u_1, v_2)\)只需要\(\bigoplus\)一个\(T(v_1, v_2)\)。

由于对称差\(\bigoplus\)运算满足交换律和结合律,所以再\(\bigoplus\)一个\(T(u_1, u_2)\)就得到\(T(u_2,v_2)\)。

假设上次查询的路径为\(u \to v\),我们维护点集\(T(u,v)\)的信息:\(in(u)\)点\(u\)是否在集合中,\(cnt(x)\)集合中权值为\(x\)点的个数,\(diff\)权值不同的点数。

查询的话如果\(LCA(u,v)\)的权值没有出现过,答案就是\(diff+1\),否则就是\(diff\)。

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
using namespace std; const int maxn = 40000 + 10;
const int maxq = 100000 + 10; struct Edge
{
int v, nxt;
Edge() {}
Edge(int v, int nxt): v(v), nxt(nxt) {}
}; int ecnt, head[maxn];
Edge edges[maxn * 2]; void AddEdge(int u, int v) {
edges[ecnt] = Edge(v, head[u]);
head[u] = ecnt++;
} int n, m; int a[maxn], b[maxn], tot; int anc[maxn][20], dep[maxn];
int group[maxn], blocks, sz; int S[maxn], top; void dfs(int u) {
int cur = top;
for(int i = head[u]; ~i; i = edges[i].nxt) {
int v = edges[i].v;
if(v == anc[u][0]) continue;
anc[v][0] = u;
dep[v] = dep[u] + 1;
dfs(v);
if(top - cur >= sz) {
blocks++;
while(top != cur) group[S[top--]] = blocks;
}
}
S[++top] = u;
} struct Query
{
int u, v, id;
bool operator < (const Query& t) const {
return group[u] < group[t.u] || (group[u] == group[t.u] && group[v] < group[t.v]);
}
}q[maxq]; void preprocess() {
for(int j = 1; (1 << j) < n; j++)
for(int i = 1; i <= n; i++) if(anc[i][j-1])
anc[i][j] = anc[anc[i][j-1]][j-1];
} int LCA(int u, int v) {
if(dep[u] < dep[v]) swap(u, v);
int log;
for(log = 0; (1 << log) < dep[u]; log++);
for(int i = log; i >= 0; i--)
if(dep[u] - (1<<i) >= dep[v]) u = anc[u][i];
if(u == v) return u;
for(int i = log; i >= 0; i--)
if(anc[u][i] && anc[u][i] != anc[v][i])
u = anc[u][i], v = anc[v][i];
return anc[u][0];
} int cnt[maxn], dif, in[maxn]; void xorvertex(int u) {
if(in[u]) { cnt[a[u]]--; if(!cnt[a[u]]) dif--; }
else { cnt[a[u]]++; if(cnt[a[u]] == 1) dif++; }
in[u] ^= 1;
} void xorpath(int u, int v) {
if(dep[u] < dep[v]) swap(u, v);
while(dep[u] > dep[v]) { xorvertex(u); u = anc[u][0]; }
while(u != v) {
xorvertex(u); xorvertex(v);
u = anc[u][0]; v = anc[v][0];
}
} int ans[maxq]; int main()
{
scanf("%d%d", &n, &m);
for(int i = 1; i <= n; i++) {
scanf("%d", a + i);
b[i] = a[i];
}
sort(b + 1, b + 1 + n);
tot = unique(b + 1, b + 1 + n) - b - 1;
for(int i = 1; i <= n; i++)
a[i] = lower_bound(b + 1, b + 1 + tot, a[i]) - b; ecnt = 0;
memset(head, -1, sizeof(head));
for(int i = 1; i < n; i++) {
int u, v; scanf("%d%d", &u, &v);
AddEdge(u, v); AddEdge(v, u);
} sz = (int)sqrt(n);
dfs(1);
while(top) group[S[top--]] = blocks;
preprocess(); for(int i = 1; i <= m; i++) {
scanf("%d%d", &q[i].u, &q[i].v);
q[i].id = i;
if(q[i].u > q[i].v) swap(q[i].u, q[i].v);
} sort(q + 1, q + 1 + m); int u = 1, v = 1;
for(int i = 1; i <= m; i++) {
xorpath(u, q[i].u);
xorpath(v, q[i].v);
u = q[i].u, v = q[i].v;
int lca = LCA(u, v);
ans[q[i].id] = dif;
if(!cnt[a[lca]]) ans[q[i].id]++;
} for(int i = 1; i <= m; i++) printf("%d\n", ans[i]); return 0;
}

SPOJ COT2 Count on a tree II 树上莫队算法的更多相关文章

  1. spoj COT2 - Count on a tree II 树上莫队

    题目链接 http://codeforces.com/blog/entry/43230树上莫队从这里学的,  受益匪浅.. #include <iostream> #include < ...

  2. SP10707 COT2 - Count on a tree II (树上莫队)

    大概学了下树上莫队, 其实就是在欧拉序上跑莫队, 特判lca即可. #include <iostream> #include <algorithm> #include < ...

  3. SP10707 COT2 - Count on a tree II [树上莫队学习笔记]

    树上莫队就是把莫队搬到树上-利用欧拉序乱搞.. 子树自然是普通莫队轻松解决了 链上的话 只能用树上莫队了吧.. 考虑多种情况 [X=LCA(X,Y)] [Y=LCA(X,Y)] else void d ...

  4. [SPOJ]Count on a tree II(树上莫队)

    树上莫队模板题. 使用欧拉序将树上路径转化为普通区间. 之后莫队维护即可.不要忘记特判LCA #include<iostream> #include<cstdio> #incl ...

  5. SPOJ COT2 - Count on a tree II(LCA+离散化+树上莫队)

    COT2 - Count on a tree II #tree You are given a tree with N nodes. The tree nodes are numbered from  ...

  6. spoj COT2 - Count on a tree II

    COT2 - Count on a tree II http://www.spoj.com/problems/COT2/ #tree You are given a tree with N nodes ...

  7. SPOJ COT2 Count on a tree II (树上莫队,倍增算法求LCA)

    题意:给一个树图,每个点的点权(比如颜色编号),m个询问,每个询问是一个区间[a,b],图中两点之间唯一路径上有多少个不同点权(即多少种颜色).n<40000,m<100000. 思路:无 ...

  8. SPOJ COT2 Count on a tree II(树上莫队)

    题目链接:http://www.spoj.com/problems/COT2/ You are given a tree with N nodes.The tree nodes are numbere ...

  9. SPOJ COT2 Count on a tree II (树上莫队)

    题目链接:http://www.spoj.com/problems/COT2/ 参考博客:http://www.cnblogs.com/xcw0754/p/4763804.html上面这个人推导部分写 ...

随机推荐

  1. go实现set

    package main import ( "fmt" "sync" ) type object interface{} type Set struct { m ...

  2. Wrinkles should merely indicate where smiles have been.

    Wrinkles should merely indicate where smiles have been. 皱纹应该只是微笑留下的印记.

  3. hashlib(加盐)回炉练习

    简介: 用于加密相关的操作,代替了md5模块和sha模块,主要提供SHA1,SHA224,SHA256,SHA384,SHA512,MD5算法.在python3中已经废弃了md5和sha模块,简单说明 ...

  4. 复选框 省市区 联动(监听input的change事件)

    需求:省市区三级包含复选框按钮以及文字描述.点击文字显示对应的下级地区,点击复选框选择对应的下级区域勾选. 分析:监听input的change事件当点击复选框省  选择对应的第一个市区,同时默认选中第 ...

  5. 动态加载sd卡或者手机内置存储卡的so库

    package com.wsc.utils; import android.content.Context; import com.wsc.common.Entrance; import com.ws ...

  6. leetcdoe Valid Anagram

    题目连接 https://leetcode.com/problems/valid-anagram/ Valid Anagram Description Given two strings s and ...

  7. SIGGRAPH 2017:深度学习与计算机图形学的碰撞

    每年由美国计算机协会(Association of Computing Machinery,简称ACM)计算机图形专业组举办的年会SIGGRAPH,是全球最负盛名的图形学和交互技术盛会.今年已经是这场 ...

  8. malloc/free函数

    一.malloc 函数原型:void *malloc(unsigned int size); 功       能:在内存的动态存储区中分配一个长度为size的连续空间. 返  回 值:指向所分配的连续 ...

  9. python+selenium之验证码的处理

    对于web应用来说,大部分的系统在用户登录时都要求用户输入验证码.验证码的类型很多,有字母数字的,有汉字的.甚至还有需要用户输入一道算术题的答案的.对于系统来说,使用验证码可以有效地防止采用机器猜测方 ...

  10. POJ 2184 Cow Exhibition 奶牛展(01背包,变形)

    题意:有只奶牛要证明奶牛不笨,所以要带一些奶牛伙伴去证明自己.牛有智商和幽默感,两者可为负的(难在这),要求所有牛的智商和之 / 幽默感之和都不为负.求两者之和的最大值. 思路:每只牛可以带或不带上, ...